resource "kubernetes_role" "kubernetes_dashboard_role" {
  metadata {
    name      = "kubernetes-dashboard-minimal"
    namespace = "kube-system"
  }

  rule {
    api_groups = [""]
    resources  = ["secrets"]
    verbs      = ["create"]
  }

  rule {
    api_groups = [""]
    resources  = ["configmaps"]
    verbs      = ["create"]
  }

  rule {
    api_groups = [""]
    resources  = ["kubernetes-dashboard-key-holder", "kubernetes-dashboard-certs"]
    verbs      = ["get", "update", "delete"]
  }

  rule {
    api_groups     = [""]
    resources      = ["configmaps"]
    resource_names = ["kubernetes-dashboard-settings"]
    verbs          = ["get", "update"]
  }

  rule {
    api_groups     = [""]
    resources      = ["services"]
    resource_names = ["heapster"]
    verbs          = ["proxy"]
  }

  rule {
    api_groups     = [""]
    resources      = ["services/proxy"]
    resource_names = ["heapster", "http:heapster:", "http:heaptser:"]
    verbs          = ["get"]
  }
}

resource "kubernetes_role_binding" "kubernetes_dashboard_role_bind" {
  metadata {
    name      = "kubernetes-dashboard-minmal"
    namespace = "kube-system"
  }

  role_ref {
    api_groups = "rbac.authorization.k8s.io"
    kind       = "Role"
    name       = "kubernetes-dashboard-minimal"
  }

  subject {
    kind = "ServiceAccount"
    name = "kubernetes-dashboard"
  }
}
